import java.util.ArrayList;
import java.util.List;

public class Block extends Syntax{
    ArrayList<Syntax> items;

    public Block(Syntax... args){
        items = new ArrayList<>();
        for (Syntax item : args) {
            items.add(item);
        }
    }

    @Override
    public void execute() {
        for (Syntax item: items) {
            item.execute();
        }
    }

    public void add(Syntax item){
        items.add(item);
    }
}
